/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef JAC_AP_CAMPRKPERSERVICE_CAMERAPARKINGPERCEPTIONSERVICE_PROXY_H
#define JAC_AP_CAMPRKPERSERVICE_CAMERAPARKINGPERCEPTIONSERVICE_PROXY_H

#include "ara/com/internal/proxy/proxy_adapter.h"
#include "ara/com/internal/proxy/event_adapter.h"
#include "ara/com/internal/proxy/field_adapter.h"
#include "ara/com/internal/proxy/method_adapter.h"
#include "ara/com/crc_verification.h"
#include "jac/ap/camprkperservice/cameraparkingperceptionservice_common.h"
#include <string>

namespace jac {
namespace ap {
namespace camprkperservice {
namespace proxy {
namespace events {
    using CamPrk2CamPrkPerceptionEvent = ara::com::internal::proxy::event::EventAdapter<::perception::Cam2CamPerceptionStruct>;
    static constexpr ara::com::internal::EntityId CameraParkingPerceptionServiceCamPrk2CamPrkPerceptionEventId = 41953U; //CamPrk2CamPrkPerceptionEvent_event_hash
}

namespace fields {
}

namespace methods {

} // namespace methods

class CameraParkingPerceptionServiceProxy {
private:
    std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
public:
    using HandleType = ara::com::HandleType;
    class ConstructionToken {
    public:
        explicit ConstructionToken(const std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> & proxy)
            : proxyAdapter(proxy),
              CamPrk2CamPrkPerceptionEvent(proxyAdapter->GetProxy(), events::CameraParkingPerceptionServiceCamPrk2CamPrkPerceptionEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

        ConstructionToken(ConstructionToken&& other) = default;
        ConstructionToken& operator=(ConstructionToken && other) = default;

        ConstructionToken(const ConstructionToken&) = delete;
        ConstructionToken& operator = (const ConstructionToken&) = delete;
        
        virtual ~ConstructionToken() = default;

        /* Do not use such internal interfaces!!! */
        ara::core::Result<void> InitializeAll()
        {
            ara::core::Result<void> initResult;
            return initResult;
        }
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> GetProxyAdapter()
        {
            return proxyAdapter;
        }
        events::CamPrk2CamPrkPerceptionEvent GetCamPrk2CamPrkPerceptionEvent() noexcept { return std::move(CamPrk2CamPrkPerceptionEvent); }
    private:
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> proxyAdapter;
        events::CamPrk2CamPrkPerceptionEvent CamPrk2CamPrkPerceptionEvent;
    };

    virtual ~CameraParkingPerceptionServiceProxy()
    {
        CamPrk2CamPrkPerceptionEvent.UnsetReceiveHandler();
        CamPrk2CamPrkPerceptionEvent.Unsubscribe();

    }

    explicit CameraParkingPerceptionServiceProxy(const HandleType &handle)
        : proxyAdapter(std::make_shared<ara::com::internal::proxy::ProxyAdapter>(::jac::ap::camprkperservice::CameraParkingPerceptionService::ServiceIdentifier, handle)),
          CamPrk2CamPrkPerceptionEvent(proxyAdapter->GetProxy(), events::CameraParkingPerceptionServiceCamPrk2CamPrkPerceptionEventId, proxyAdapter->GetHandle(), proxyAdapter->GetServiceInterfaceInfo()){
        }

    void ThrowError(const ara::core::Result<void>& result) const
    {
        if (!(result.HasValue())) {
#ifndef NOT_SUPPORT_EXCEPTIONS
            ara::core::ErrorCode errorcode(result.Error());
            throw ara::com::ComException(std::move(errorcode));
#else
            std::cerr << "Error: Not support exception, create proxy failed!"<< std::endl;
#endif
        }
    }

    CameraParkingPerceptionServiceProxy(const CameraParkingPerceptionServiceProxy&) = delete;
    CameraParkingPerceptionServiceProxy& operator=(const CameraParkingPerceptionServiceProxy&) = delete;

    CameraParkingPerceptionServiceProxy(CameraParkingPerceptionServiceProxy&&) = default;
    CameraParkingPerceptionServiceProxy& operator=(CameraParkingPerceptionServiceProxy&&) = default;
    CameraParkingPerceptionServiceProxy(ConstructionToken&& token) noexcept
        : proxyAdapter(token.GetProxyAdapter()),
          CamPrk2CamPrkPerceptionEvent(token.GetCamPrk2CamPrkPerceptionEvent()){
        static_cast<void>(std::move(token));
    }

    static ara::core::Result<ConstructionToken> Preconstruct(
        const ara::com::HandleType &handle)
    {
        std::shared_ptr<ara::com::internal::proxy::ProxyAdapter> preProxyAdapter =
            std::make_shared<ara::com::internal::proxy::ProxyAdapter>(
               ::jac::ap::camprkperservice::CameraParkingPerceptionService::ServiceIdentifier, handle);
        ConstructionToken token{std::move(preProxyAdapter)};
        ara::core::Result<void> initResult {token.InitializeAll()};
        if (initResult.HasValue()) {
            return ara::core::Result<ConstructionToken>(std::move(token));
        } else {
            const ara::core::ErrorCode errorcode{initResult.Error()};
            ara::core::Result<CameraParkingPerceptionServiceProxy::ConstructionToken> preResult{errorcode};
            return preResult;
        }
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType>& handler,
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::camprkperservice::CameraParkingPerceptionService::ServiceIdentifier, instance);
    }

    static ara::com::FindServiceHandle StartFindService(
        const ara::com::FindServiceHandler<ara::com::internal::proxy::ProxyAdapter::HandleType> handler,
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::StartFindService(handler, ::jac::ap::camprkperservice::CameraParkingPerceptionService::ServiceIdentifier, specifier);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::com::InstanceIdentifier instance)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::camprkperservice::CameraParkingPerceptionService::ServiceIdentifier, instance);
    }

    static ara::com::ServiceHandleContainer<ara::com::internal::proxy::ProxyAdapter::HandleType> FindService(
        const ara::core::InstanceSpecifier specifier)
    {
        return ara::com::internal::proxy::ProxyAdapter::FindService(::jac::ap::camprkperservice::CameraParkingPerceptionService::ServiceIdentifier, specifier);
    }

    static void StopFindService(const ara::com::FindServiceHandle& handle)
    {
        ara::com::internal::proxy::ProxyAdapter::StopFindService(handle);
    }

    HandleType GetHandle() const
    {
        return proxyAdapter->GetHandle();
    }
    bool SetEventThreadNumber(const std::uint16_t number, const std::uint16_t queueSize)
    {
        return proxyAdapter->SetEventThreadNumber(number, queueSize);
    }
    events::CamPrk2CamPrkPerceptionEvent CamPrk2CamPrkPerceptionEvent;
};
} // namespace proxy
} // namespace camprkperservice
} // namespace ap
} // namespace jac

#endif // JAC_AP_CAMPRKPERSERVICE_CAMERAPARKINGPERCEPTIONSERVICE_PROXY_H
